<?php
/*TrackRef, Copyright Michael Carlozzi 2016

This PHP file is part of TrackRef.

TrackRef is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

TrackRef is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with TrackRef. If not, see <http://www.gnu.org/licenses/>.
*/
session_start(); include 'settings.php'; $lines = file('settings.php');

if (!isset($_SESSION['username'])) { Header("Location: index.php"); die(); } else $loginUser = $_SESSION['username'];
if (isset($_POST['updateUser'])) {
	$loginPass = mysqli_real_escape_string($con, $_POST['password']); $email = mysqli_real_escape_string($con,$_POST['email']);
	if ($loginPass != '') { $loginPass = sha1($loginPass); $update = "UPDATE users SET password = '$loginPass' WHERE username = '$loginUser'";  mysqli_query($con, $update); $_SESSION['updatePass'] = 1;}
	if ($email != '') { $update = "UPDATE users SET email = '$email' WHERE username = '$loginUser'"; mysqli_query($con,$update); $_SESSION['updatePass'] = 1; }
	if (isset($_POST['location'])) {
		$locationPost = mysqli_real_escape_string($con,$_POST['location']); 
		$update = "UPDATE users SET location = '$locationPost' WHERE username = '$loginUser'"; $con->query($update);
	}
	if (isset($_POST['cookies'])) {
		$cookieValue = mysqli_real_escape_string($con,$_POST['cookies']); if ($cookieValue == 'Yes') { $update = "UPDATE users SET enableCookie = '1' WHERE username = '$loginUser'"; $con->query($update); $random = generateRandomString(48); $cookieQuery = "UPDATE users SET cookie = '$random' WHERE username = '$loginUser'"; mysqli_query($con,$cookieQuery); setcookie("auth", $random, time() + (86400 * 60)); } 
		else { $update = "UPDATE users SET enableCookie = '0' WHERE username = '$loginUser'"; $con->query($update); setcookie("auth", "", time()-3600);} }
}
if (isset($_POST['AddUser'])) {
	$recordUser = mysqli_real_escape_string($con,$_POST['username']); $recordPass = mysqli_real_escape_string($con, $_POST['password']);
	$recordLocation = mysqli_real_escape_string($con,$_POST['libraryAssign']);
	if ($recordUser != '' && $recordPass != '') {
		$recordPass = sha1($recordPass);
		$insert = "INSERT INTO users (username, password, location) VALUES ('$recordUser', '$recordPass', '$recordLocation')"; mysqli_query($con,$insert);
		$_SESSION['updatePass'] = 1;
	}
}
if (isset($_POST['addLocation'])) {
	$location = mysqli_real_escape_string($con, $_POST['libraryLocation']); if ($location != '') { $insert = "INSERT INTO librarydata (spot) VALUES ('$location')"; mysqli_query($con,$insert); $_SESSION['updatePass'] = 1;}
}
if (isset($_POST['updateTransaction'])) {
	$old = $_POST['transact']; $new = mysqli_real_escape_string($con, $_POST['rename']); 
	$update = "UPDATE transactions SET type = '$new' WHERE type = '$old'"; mysqli_query($con,$update);
	$_SESSION['updatePass'] = 1;
}
if (isset($_POST['removeTransaction'])) {
$remove = mysqli_real_escape_string($con,$_POST['transact']);
$query = "DELETE FROM transactions WHERE type = '$remove'"; $con->query($query);
}
if (isset($_POST['city'])) { //editing timezone code; directly modifies settings.php page
$matches = array();
foreach ($lines as $str) { if (preg_match('/^date_default/', $str, $m)) { $matches[] = $m; $dateString = $str; } }
$subDate = substr($dateString, 26,-4); $oldDate = substr($dateString, 0, 27);
$newDate = "'"; $newDate .= $_POST['city']; $newDate .= "'"; $dateEnd = substr($dateString, -5); $totalDate = $oldDate . $newDate . $dateEnd;
// add new date
$lines = str_replace("$subDate", "$newDate", $lines); $matches = array(); $empty = '"'; $_SESSION['updatePass'] = 1; file_put_contents('settings.php',$lines); }
if (isset($_POST['export'])) { //exporting data to a CSV
	$sql = "SELECT * FROM transactions";$result = mysqli_query($con,$sql);$fp = fopen('transactions.csv', 'w');
    while($row = mysqli_fetch_assoc($result))
    { fputcsv($fp, $row); } 
	fclose($fp);
	$_SESSION['exported'] = 1;
	$file = "transactions.csv";
	if (file_exists($file)) {
    header('Content-Description: File Transfer'); header('Content-Type: application/octet-stream'); header('Content-Disposition: attachment; filename="'.basename($file).'"');
    header('Expires: 0');
    header('Cache-Control: must-revalidate'); header('Pragma: public'); header('Content-Length: ' . filesize($file)); readfile($file);} }
?>
<html><head><title>TrackRef Settings</title><link rel='stylesheet' href='design.css'>
<body>
<div id='main'>
<ul class='navbar'>
  <li class='navbar'><a class="active" href="index.php">Home</a></li>
  <li class='navbar'><a href="analysis.php">Analytics</a></li>
  <li class='navbar'><a href="edit.php">Settings</a></li>
  <li class='navbar'><a href="manual.php">Manual Entry</a></li>
  <?php if ($editRows == 1) { echo "<li class='navbar'><a href='remove.php'>Edit</a></li>"; }
  if (isset($_SESSION['username'])) echo "<li class='navbar'><a href='transaction.php?logout=1'>Logout</a></li>";?>
</ul>
<?php //update notifications
if (isset($_SESSION['updatePass'])) { echo "<p class='update'>Settings successfully updated.</p>"; unset($_SESSION['updatePass']);}
if (isset($_SESSION['exported'])) { echo "<p class='update'>Database successfully exported.</p>"; unset($_SESSION['exported']);}
?>
<h2>User Settings</h2>
<form method='POST' action=''>
<?php
echo "<table>";
$query = "SELECT * FROM users WHERE username = '$loginUser'"; $result = mysqli_query($con,$query);
$data = mysqli_fetch_array($result); $query2 = "SELECT * FROM librarydata"; $result2 = mysqli_query($con,$query2); 
echo "<tr><td><strong>Password:</td><td><input type='password' name='password'></td></tr>";
echo "<tr><td><strong>Email:</td><td><input type='text' name='email' value='$data[email]'></td></tr>";
echo "<tr><td><strong>Location:</td><td><select name='location'>";
while ($librarydata = mysqli_fetch_array($result2)) {
	echo "<option "; if ($librarydata['spot'] == $data['location']) { echo "selected "; }
	echo "value='$librarydata[spot]'>$librarydata[spot]</option>";
}
echo "</select></td></tr>";
echo "<tr><td><strong>Use Cookies:</td><td><input type='radio' name='cookies' value='Yes' ";
if ($data['enableCookie'] == 1) echo "checked='checked' "; 
echo ">Yes</input></td><td><input type='radio' name='cookies' value='No' ";
if ($data['enableCookie'] == 0) echo "checked='checked' "; 
echo ">No</input></td></tr>";
?>
<tr><td><input type='submit' value='Update User Settings' name='updateUser'></input></td></tr>
</form></table></form>
<?php
if ($data['admin'] == 1) {
	echo "<h2>Administrator Settings</h2>";
	echo "<p><strong>Create library location:</strong></p><form method='POST' action=''>";
	echo "<table><tr><td><strong>Name:</td><td><input type='text' name='libraryLocation'></input></td></tr>";
	echo "<tr><td><input type='submit' value='Add Location' name='addLocation'></input></td></tr></form></table>";
	echo "<h3>Replace Existing Data</h2>";
	echo "<p>Here you can modify data already in your database. For instance, you may have been
	calling directional questions 'operational' but now want to term them 'directional.' Choose the value you wish to change and
	then enter a new value next to it. <strong>You must also update the settings.php page so
	new entries will reflect changed values.</strong></p>";
	echo "<table><form method='POST' action=''><tr><td><strong>Old Value:</td><td><select name='transact'>";
	$query = "SELECT DISTINCT type FROM transactions"; $result3 = mysqli_query($con,$query);
	while ($transactionData = mysqli_fetch_array($result3)) {
		$type = $transactionData['type'];
		echo "<option value='$type'>$type</option>";
	}
	echo "</td><td><strong>New Value:</td><td><input type='text' name='rename'></input></td></tr>";
	echo "<tr><td><input type='submit' value='Update' name='updateTransaction'></input></td></tr></table></form>";
	echo "<h3>Add New User</h3>";
	echo "<p>Add staff to your database. Advise the staff member to change the password asap.";
	echo "<form method='POST' action=''><table>";
	echo "<tr><td><strong>Username:</td><td><input type='text' name='username'></input></td></tr>";
	echo "<tr><td><strong>Password:</td><td><input type='text' name='password'></input></td></tr>";
	echo "<tr><td><strong>Location:</td><td><select name='libraryAssign'>";
	$test = "SELECT * FROM librarydata"; $testResult = mysqli_query($con,$test);
	while ($libdata = mysqli_fetch_array($testResult)) {
		$spot = $libdata['spot'];
	echo "<option value=$spot>$spot</option>";
	}
	echo "</select><tr><td><input type='submit' value='Add User' name='AddUser'></input></form></table>";
	echo "<h3>Change Time Zone</h3>";
	echo "<table><form method='POST' action=''>";
	echo "<tr><td><strong>Set Time Zone:</td><td><select name='city' >";
	echo "<option value='Pacific/Midway'>(GMT-11:00) Midway Island, Samoa</option>
<option value='Etc/GMT+10'>(GMT-10:00) Hawaii</option>
<option value='Pacific/Marquesas'>(GMT-09:30) Marquesas Islands</option>
<option value='Pacific/Gambier'>(GMT-09:00) Gambier Islands</option>
<option value='America/Anchorage'>(GMT-09:00) Alaska</option>
<option value='America/Los_Angeles'>(GMT-08:00) Pacific Time (US & Canada)</option>
<option value='America/Denver'>(GMT-07:00) Mountain Time (US & Canada)</option>
<option value='America/Chicago'>(GMT-06:00) Central Time (US & Canada)</option>
<option selected value='America/New_York'>(GMT-05:00) Eastern Time (US & Canada)</option>
<option value='America/Caracas'>(GMT-04:30) Caracas</option>
<option value='America/Glace_Bay'>(GMT-04:00) Atlantic Time (Canada)</option>
<option value='America/St_Johns'>(GMT-03:30) Newfoundland</option>
<option value='America/Araguaina'>(GMT-03:00) UTC-3</option>
<option value='America/Godthab'>(GMT-03:00) Greenland</option>
<option value='America/Noronha'>(GMT-02:00) Mid-Atlantic</option>
<option value='Atlantic/Azores'>(GMT-01:00) Azores</option>
<option value='Europe/London'>(GMT) Greenwich Mean Time : London</option>
<option value='Europe/Amsterdam'>(GMT+01:00) Amsterdam, Berlin, Bern, Rome, Stockholm, Vienna</option>
<option value='Africa/Cairo'>(GMT+02:00) Cairo</option>
<option value='Asia/Damascus'>(GMT+02:00) Syria</option>
<option value='Europe/Moscow'>(GMT+03:00) Moscow, St. Petersburg, Volgograd</option>
<option value='Asia/Tehran'>(GMT+03:30) Tehran</option>
<option value='Asia/Dubai'>(GMT+04:00) Abu Dhabi, Muscat</option>
<option value='Asia/Kabul'>(GMT+04:30) Kabul</option>
<option value='Asia/Yekaterinburg'>(GMT+05:00) Ekaterinburg</option>
<option value='Asia/Kolkata'>(GMT+05:30) Chennai, Kolkata, Mumbai, New Delhi</option>
<option value='Asia/Katmandu'>(GMT+05:45) Kathmandu</option>
<option value='Asia/Novosibirsk'>(GMT+06:00) Novosibirsk</option>
<option value='Asia/Rangoon'>(GMT+06:30) Yangon (Rangoon)</option>
<option value='Asia/Bangkok'>(GMT+07:00) Bangkok, Hanoi, Jakarta</option>
<option value='Asia/Hong_Kong'>(GMT+08:00) Beijing, Chongqing, Hong Kong, Urumqi</option>
<option value='Australia/Eucla'>(GMT+08:45) Eucla</option>
<option value='Asia/Seoul'>(GMT+09:00) Seoul</option>
<option value='Australia/Darwin'>(GMT+09:30) Darwin</option>
<option value='Asia/Vladivostok'>(GMT+10:00) Vladivostok</option>
<option value='Australia/Lord_Howe'>(GMT+10:30) Lord Howe Island</option>
<option value='Asia/Magadan'>(GMT+11:00) Magadan</option>
<option value='Pacific/Norfolk'>(GMT+11:30) Norfolk Island</option>
<option value='Pacific/Auckland'>(GMT+12:00) Auckland, Wellington</option>
<option value='Pacific/Chatham'>(GMT+12:45) Chatham Islands</option>
<option value='Pacific/Tongatapu'>(GMT+13:00) Nuku'alofa</option>
<option value='Pacific/Kiritimati'>(GMT+14:00) Kiritimati</option>
</select></td>
</tr>
</table>
<input type='submit' value='Update Time'></input></form>";
echo "<h3>Delete Categorical Data</h3>";
echo "<p>To remove individual transactions, visit <a href='remove.php'> the remove page </a> after enabling it in settings.php. However you can remove categories of data that you no longer want or need. For instance, you may
have stopped tracking questions related to EBooks, so you would like those removed completely from the database.";
echo "<table><form method='POST' action=''><tr><td><strong>Category:</td><td><select name='transact'>";
	$query = "SELECT DISTINCT type FROM transactions"; $result4 = mysqli_query($con,$query);
	while ($transactionData = mysqli_fetch_array($result4)) {
		$type = $transactionData['type'];
		echo "<option value='$type'>$type</option>";
	}
	echo "<tr><td><input type='submit' value='Remove' name='removeTransaction'></input></td></tr></table></form>";
}
else {
	echo "<h3>Hey...how do I change the transactions?</h3>";
	echo "<p>Transactions can only be modified by the administrator, the person who made your account. You can only change user settings such as password and email.</p>";
}
echo "<h3>Export Database to CSV</h3>";
echo "<p>To download your data in .CSV format, select this option.</p>";
echo "<form method='POST' action=''><input type='submit' value='Export' name='export'></input></form>";
$con->close();
?>
</div>
</body></html>