<?php
/*TrackRef, Copyright Michael Carlozzi 2016

This PHP file is part of TrackRef.

TrackRef is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

TrackRef is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with TrackRef. If not, see <http://www.gnu.org/licenses/>.
*/
session_start();
if (!isset($_SESSION['username'])) { Header("Location: index.php"); die();}	else $loginUser = $_SESSION['username'];
include('settings.php');

if (isset($_POST['submit'])) {
	$entryDate = $_POST['date']; $weekDay = date('l', strtotime($entryDate)); $month = date('F', strtotime($entryDate));
	$entryTime = $_POST['time']; $entryTime = strtoupper($entryTime); $year = date('Y', strtotime($entryDate));
	$transaction = $_POST['transaction']; $loc = $_POST['location']; 
	if (isset($_POST['difficulty'])) { $difficulty = $_POST['difficulty']; }
	$length = strlen($entryTime);
	$details = mysqli_real_escape_string($con, $_POST['details']);
	if ($length > 8 && $length < 7) {
		$_SESSION['invalid'] = 1;
	}
	else {
		if (!isset($difficulty)) { $difficulty = '';}
		$query = "INSERT INTO transactions (date, weekDay, month, type, time, difficulty, year, details, staff, location) VALUES 
		('$entryDate', '$weekDay', '$month', '$transaction', '$entryTime', '$difficulty', '$year', '$details', '$loginUser', '$loc')";
		mysqli_query($con, $query);
		$_SESSION['success'] = 1;
		$_SESSION['date'] = $entryDate;
	}
}
if (isset($_SESSION['date'])) {
	$date = $_SESSION['date']; $time = date('g:i A'); 
	unset($_SESSION['date']);
}
else $date = date('m/j/Y'); $time = date('g:i A');
?>
<html>
<head><title>TrackRef Manual Entry</title>
<link rel='stylesheet' href='design.css'>
</head>
<body>
<div id='main'>
<ul class='navbar'>
  <li class='navbar'><a class="active" href="index.php">Home</a></li>
  <li class='navbar'><a href="analysis.php">Analytics</a></li>
  <li class='navbar'><a href="edit.php">Settings</a></li>
  <li class='navbar'><a href="manual.php">Manual Entry</a></li>
   <?php if ($editRows == 1) { echo "<li class='navbar'><a href='remove.php'>Edit</a></li>"; }
  if (isset($_SESSION['username'])) echo "<li class='navbar'><a href='transaction.php?logout=1'>Logout</a></li>";?>
</ul>
<h2>Manually Record Transactions</h2>
<?php
if (isset($_SESSION['invalid'])) {
	echo "<br/><p class='alert'>Time entered is invalid. Please use the format 12:00 AM</p>";
	unset($_SESSION['invalid']);
} 
if (isset($_SESSION['success'])) {
	echo "<br/><p class='alert'>Transaction successfully recorded.</p>";
	unset($_SESSION['success']);
}

?>
<table><form method='POST' action=''>
<tr><td><strong>Date:</td><td><input type='text' name='date' value='<?php echo "$date";?>'></input></td></tr>
<tr><td><strong>Time:</td><td><input type='text' name='time' value='<?php echo "$time";?>'></input></td></tr>
<tr><td><strong>Transaction:</td><td><select name='transaction'>
<?php
if ($detailedSettings == 0) { array_push($total, $info);}
sort($total); //this is where the data is sorted

foreach ($total as $key => $value) {
	if ($detailedSettings == 0) { echo "<option name='$value'>$value</option>"; }
	else {
	echo "<option name='$value[0]'>$value[0]</option>";
	}
}
echo "</select></td></tr>";
?>
<tr><td><strong>Location:</td><td><select name='location'>
<?php
$getLocation = "SELECT DISTINCT location FROM transactions"; $resultLoc = mysqli_query($con, $getLocation); 
while ($data = mysqli_fetch_array($resultLoc)) {
	$location = $data['location'];
	echo "<option name='$location'>$location</option>";
}
echo "</select>";
if (isset($info)) { 
echo "<tr><td><strong>Difficulty (for $info):<td><input type='text' name='difficulty'></input></td></tr>";
}
$con->close();
?>
<tr><td><strong>Details:</td><td><input type='text' name='details'></input></td></tr>
<tr><td><input type='submit' name='submit' value='Record'></input>
</table></form>
</div></body></html>