<?php
/*TrackRef, Copyright Michael Carlozzi 2016

This PHP file is part of TrackRef.

TrackRef is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

TrackRef is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with TrackRef. If not, see <http://www.gnu.org/licenses/>.
*/
/*GENERAL SETTINGS
SET VARIABLES = 1 TO ENABLE; 0 TO DISABLE
*/

/*DATABASE SETTINGS
You need to configure variables to interface with SQL; leave $con alone
*/
$user = 'root'; $password = ''; $database = 'reference'; $host = 'localhost';
$con = mysqli_connect($host, $user, $password, $database);
$createDB = mysqli_connect($host,$user,$password); // for creating database
/*LOGIN REQUIRED
If you want your users to login (create accounts), set this to 1 (default), otherwise set to 0 (anyone can then access
the page; easier, but obviously less secure; may be useful on standalone systems 
*/
$login = 1;

/*CONFIRM REQUIRED
If you want users to confirm through Javascript a transaction. By default this is 0 (off); change to 1 to turn it on. Default
means you click less but may make errors.
*/
$confirm = 1;

/*TIME ZONE VALID ENTRIES*
Modify this file through the user settings page, not here*/
date_default_timezone_set('America/New_York');

//REFERENCE TRANSACTIONS
/*You can record as many reference transactions as you'd like. Simply enter the name next to the variable: you can have a maximum of 15 variables. 
NOTE, the first variable of "Information" is designed for RESEARCH related questions. When you click on its button, a popup window will ask you to rate the degree of
difficulty/time_intensiveness the question posed. You can use whatever scale you'd like. The data must be numeric if you want
to use averages.

If you want a category to enter additional information, please use the academicsettings.php file instead.
*/

$total = array(
'crucial' => "Information",
't1' => "Access",
't2' => "Circulation",
't3' => "Change",
't4' => "Technology",
't5' => "Fax",
't6' => "Photocopy",
't7' => "Study",
't8' => "EBook",
't9' => "Scanning",
't10' => "Location",
);
$info = $total['crucial']; unset($total['crucial']); 

//LINE BREAKS: enter the number you want to start a new line of buttons on the main page.
$break = 4;
function generateRandomString($length = 10) { $characters = '0123456789abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ'; $charactersLength = strlen($characters); $randomString = ''; for ($i = 0; $i < $length; $i++) {$randomString .= $characters[rand(0, $charactersLength - 1)]; } return $randomString; } // for cookies
/*GRAPH TIMES*
The times below will appear in your charts. Remove any values that you don't wish to see in the $graphData array; if you don't wish to display military time, you can 
also change the number shown. To add more, simply follow the convention, using the correct variable name (i.e. $tenAM for 10:00 AM and $tenPM for 10:00 PM)

By default, the graphs will show you values from 10:00 AM to 8:59 PM. ($tenAM - $eightPM).

I don't include a midnight variable because you shouldn't ever have anyone working reference at midnight. 
*/
$oneAM = $twoAM = $threeAM = $fourAM = $fiveAM = $sixAM = $sevenAM = $eightAM = $nineAM = $tenAM = $elevenAM = $noon = $onePM = $twoPM = $threePM = $fourPM = $fivePM = $sixPM = $sevenPM = $eightPM = 0;
$graphData = array(
	"10:00" => $tenAM, 
	"11:00" => $elevenAM,
	"12:00" => $noon, 
	"1:00" => $onePM,
	"2:00" => $twoPM, 
	"3:00" => $threePM,
	"4:00" => $fourPM, 
	"5:00" => $fivePM,
	"6:00" => $sixPM, 
	"7:00" => $sevenPM,
	"8:00" => $eightPM
	);
$detailedSettings = 0; // to tell the program to do stuff 
$editRows = 1; //option for users to edit rows associated with their names
?>